#!- Animation template --------------------------------------------------------
#TEMPLATE(ProgressAnimateABC,'Animation Template *DM*'),FAMILY('ABC')
#!- Global Equates and Prototypes Declarations --------------------------------
#EXTENSION(ProgressAnimateGlobals,'Global declarations for Progress Bar Animation *DM*'),APPLICATION
#DISPLAY('Global declarations for Progress Bar Animation')
#DISPLAY('are not mandatory, if included already in another way.')
#AT(%GlobalMap)
!ProgressAnimate Prototypes
 MODULE('AnimationAPI')
   CreateWindowExA(LONG,*CSTRING,LONG,ULONG,SIGNED,SIGNED,SIGNED,SIGNED,UNSIGNED,UNSIGNED,UNSIGNED,LONG),UNSIGNED,PASCAL,RAW
   SendMessage(UNSIGNED,UNSIGNED,UNSIGNED,LONG),LONG,PASCAL,NAME('SendMessageA')
   DestroyWindow(UNSIGNED),BOOL,PASCAL
   ShowWindow(UNSIGNED,SIGNED),SIGNED,PASCAL
 END
#ENDAT
#AT (%AfterGlobalIncludes)
!ProgressAnimate Equates
WS_CHILD            EQUATE(040000000h)
ANIMATE_CLASS       EQUATE('SysAnimate32')
SW_NORMAL           EQUATE(1)
SW_SHOWNORMAL       EQUATE(1)
ACS_TRANSPARENT     EQUATE(2)
ACM_OPEN            EQUATE(1124) !WM_USER+100
ACM_PLAY            EQUATE(1125) !WM_USER+101
ACM_STOP            EQUATE(1126) !WM_USER+102
#ENDAT
#!- Local Extension for Report and Process Procedures -------------------------
#EXTENSION(ProgressAnimate,'Progress Bar Animation *DM*'),PROCEDURE
#!- Available only for Report and Process Procedures --------------------------
#RESTRICT
  #IF (UPPER(%ProcedureTemplate) = 'REPORT' OR UPPER(%ProcedureTemplate) = 'PROCESS')
    #ACCEPT
  #ELSE
    #REJECT
  #ENDIF
#ENDRESTRICT
#DISPLAY('Changes the appearance of the Progress Window,')
#DISPLAY('and displays avi file instead of standard Progress bar.')
#DISPLAY()
#DISPLAY('Avi file must be included as resource.')
#PROMPT('Avi Resource name:',@s20),%AviName,REQ,DEFAULT('#101')
#!- Local variables declaration -----------------------------------------------
#AT(%DataSection),PRIORITY(4000)
LOC:AniName          CSTRING(32)
LOC:AniHWnd          UNSIGNED
LOC:AniClassName     CSTRING(32)
LOC:AniStyle         ULONG
LOC:RgnEqu           SIGNED
#ENDAT
#!- Change Progress Window appearance and start animation ---------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8600)
!ProgressAnimate Start
0{PROP:Pixels} = True !needed to get new font properties for a window
0{PROP:FontName} = 'Tahoma'
0{PROP:FontSize} = 8
0{PROP:FontStyle} = FONT:Regular
0{PROP:FontCharSet} = CHARSET:EastEurope
0{PROP:Pixels} = False
0{PROP:Text} = 'Printing...'
0{PROP:Width} = 184
0{PROP:Height} = 58
HIDE(?Progress:PctText)
HIDE(?Progress:Thermometer)
LOC:RgnEqu = CREATE(0,CREATE:Region)
SETPOSITION(LOC:RgnEqu,32,24,120,12)
SETFONT(LOC:RgnEqu,'Tahoma',8,,FONT:Regular,CHARSET:EastEurope)
UNHIDE(LOC:RgnEqu)
SETPOSITION(?Progress:UserString,4,8,176,12)
SETFONT(?Progress:UserString,'Tahoma',8,,FONT:Bold,CHARSET:EastEurope)
SETPOSITION(?Progress:Cancel,60,40,64,14)
SETFONT(?Progress:Cancel,'Tahoma',8,,FONT:Regular,CHARSET:EastEurope)
?Progress:Cancel{PROP:Text} = 'Cancel'
LOC:AniName = '%AviName'
0{PROP:Pixels}=True
LOC:AniClassName = ANIMATE_CLASS
LOC:AniStyle = WS_CHILD+ACS_TRANSPARENT
LOC:AniHWnd = CreateWindowExa(0,LOC:AniClassName,0,LOC:AniStyle,|
 LOC:RgnEqu{PROP:xpos},LOC:RgnEqu{PROP:ypos},LOC:RgnEqu{PROP:width},LOC:RgnEqu{PROP:height},|
 0{PROP:Handle},1,SYSTEM{PROP:AppInstance},0)
0{PROP:Pixels}=False
Erc# = SendMessage(LOC:AniHWnd,ACM_OPEN,SYSTEM{PROP:AppInstance},ADDRESS(LOC:AniName))
Erc# = SendMessage(LOC:AniHWnd,ACM_PLAY,-1,0FFFF0000h)
Erc# = ShowWindow(LOC:AniHWnd,SW_NORMAL)
DISPLAY()
#ENDAT
#!- Stop animation and clean up -----------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(5500)
!ProgressAnimate Stop
Erc# = SendMessage(LOC:AniHWnd,ACM_STOP,0,0)
Erc# = DestroyWindow(LOC:AniHWnd)
#ENDAT
